# CLISP manual page

- Name
- Synopsis
- Description
- Options
#ifdef AMIGAOS
- Workbench
#endif
- Reference
- Use
- Files
#ifdef HAVE_ENVIRONMENT
- Environment
#endif
- See also
- Bugs
- Projects
- Authors

## Name

`CLISP` - ANSI Common Lisp compiler, debugger and interpreter.

## Synopsis

`clisp` [ `-h` | `--help` ] [ `--version` ] [ `--license` ] [ `-B` lisplibdir ] #ifdef UNIX [ `-K` linking-set ] #endif [ `-M` memfile ] [ `-m` memsize ] #ifndef NO_SP_MALLOC [ `-s` stacksize ] #endif #ifdef MULTIMAP_MEMORY_VIA_FILE [ `-t` tempdir ] #endif [ `-L` language ] [ `-N` localedir ] [ `-E` domain encoding ] [ `-q` | `--quiet` | `--silent` ] [ `-w` ] [ `-I` ] [ `-ansi` ] [ `-traditional` ] [ `-p` packagename ] [ `-C` ] [ `-norc` ] [ `-i` initfile ... ] [ `-c` [ `-l` ] lispfile [ `-o` outputfile ] ... ] [ `-x` expression ] [ lispfile [ argument ... ] ]

## Description

Invokes the Common Lisp interpreter and compiler. Invoked without arguments, executes a read-eval-print loop, in which expressions are in turn read from standard input, evaluated by the lisp interpreter, and their results output to standard output. Invoked with `-c`, compiles the specified lisp files to a bytecode that can be executed more efficiently.

## Options

`-h`, `--help`
  Displays a help message on how to use `clisp`.

`--version`
  Displays the `clisp` version number, as given by the function call `(lisp-implementation-version)`.

`--license`
  Displays a summary of the licensing information, the GNU GPL.

`-B` lisplibdir
  Specifies the installation directory. This is the directory containing the linking sets and other data files. #ifdef UNIX This option is normally not necessary, because the installation directory is already built-in in the `clisp` executable. #endif Directory lisplibdir can be changed at run-time using the symbol-macro `*lib-directory*`.

#ifdef UNIX
`-K` linking-set
  Specifies the linking set to be run. This is a directory containing at least a main executable and an initial memory image. Possible values are `base`, `full`. The default is `base`.

#endif
`-M` memfile
  Specifies the initial memory image. This must be a memory dump produced by the `saveinitmem` function. #ifdef UNIX It may have been compressed using GNU gzip. #endif

`-m` memsize
  Sets the amount of memory `clisp` tries to grab on startup. The amount may be given as
  - nnnnnnn (measured in bytes),
  - nnnn `K` or nnnn `KB` (measured in kilobytes) or
  - n `M` or n `MB` (measured in megabytes).
  #ifdef WIDE Default is 4 megabytes. #else Default is 2 megabytes. #endif #if (oint_addr_len+addr_shift==24) The argument is constrained between 100 KB and 16 MB. #elif (oint_addr_len+addr_shift==26) The argument is constrained between 100 KB and 64 MB. #elif (oint_addr_len+addr_shift==28) The argument is constrained between 100 KB and 256 MB. #else The argument is constrained above 100 KB. #endif -- This version of `clisp` #if defined(SPVW_MIXED) && defined(SPVW_BLOCKS) #ifdef GENERATIONAL_GC is not likely to actually use the entire memsize since garbage collection will periodically reduce the amount of used memory. It is therefore common to specify 10 MB even if only 2 MB are going to be used. #else eventually uses the entire memsize. #endif #else allocates memory dynamically. memsize is essentially ignored. #endif

#ifndef NO_SP_MALLOC
`-s` stacksize
  Sets the size of the stack `clisp` allocates for itself. The syntax is the same as for memsize. Default is one eighth of memsize. The argument is constrained between 40 KB and 8 MB.

#endif #ifdef MULTIMAP_MEMORY_VIA_FILE
`-t` tempdir
  specifies the directory where the temporary core file is to be held. This option takes precedence over the environment variable `TMPDIR`.

#endif
`-L` language
  Specifies the language `clisp` uses to communicate with the user. This may be #ifndef GNU_GETTEXT `english`. #endif #ifdef GNU_GETTEXT `english`, `deutsch`, `francais`, `espanol`, `dutch`. Other languages may be specified through the environment variable `LANG`, provided the corresponding message catalog is installed. #endif The language may be changed at run-time using the symbol macro `*current-language*`,

`-N` localedir
  Specifies the base directory of locale files. `clisp` will search its message catalogs in localedir`/`language`/LC_MESSAGES/clisp.mo`. This directory may be changed at run-time using the symbol macro `*current-language*`,

`-E` domain encoding
  Specifies the encoding used for a given domain, overriding the default which depends on the environment variables `LC_ALL`, `LC_CTYPE`, `LANG`. domain can be
  `file`,
    affecting `*default-file-encoding*`, or
  `pathname`,
    affecting `*pathname-encoding*`, or
  `terminal`,
    affecting `*terminal-encoding*`, or
  `foreign`,
    affecting `*foreign-encoding*`, or
  `misc`,
    affecting `*misc-encoding*`.
  Note that these values cannot be saved in a memory inage. You have to use the init file to set them on startup.

`-q`, `--quiet`, `--silent`
  Quiet: `clisp` displays no banner at startup and no good-bye message when quitting.

`-w`
  Wait for a keypress after program termination.

`-I`
  Be ILISP friendly. ILISP is an alternative Emacs interface to Common Lisp systems. With this option, `clisp` interacts in a way that ILISP can deal with. Currently the only effect of this is that unnecessary prompts are not suppressed. #ifdef GNU_READLINE Furthermore, the GNU readline library treats Tab as a normal self-inserting character. #endif

`-ansi`
  ANSI CL compliant: comply with the ANSI CL specification even where CLISP has been traditionally different. It sets the symbol macro `*ansi*` to `t`. See "Maximum ANSI CL compliance", for details.

`-traditional`
  Traditional: reverses the residual effects of `-ansi` in the saved image.

`-p` packagename
  At startup the value of the variable `*package*` will be set to the package named packagename. The default is the package which was active when the image was saved, normally `USER`.

`-C`
  Compile when loading: At startup the value of the variable `*load-compiling*` will be set to `t`. Code being `load`ed will then be compiled on the fly. This results in slower loading, but faster execution.

`-norc`
  Normally `clisp` loads a user run control (RC) file on startup (this happens after the `-C` option is processed). The file loaded is #if defined(PATHNAME_MSDOS) || defined(PATHNAME_OS2) || defined(PATHNAME_WIN32) || defined(PATHNAME_RISCOS) `_clisprc.lisp` or `_clisprc.fas` in the home directory `(user-homedir-pathname)`, #endif #if defined(PATHNAME_AMIGAOS) `.clisprc.lisp` or `.clisprc.fas` in the home directory `(user-homedir-pathname)`, #endif #if defined(PATHNAME_UNIX) `${HOME}/.clisprc.lisp` or `${HOME}/.clisprc.fas`, #endif whichever is newest. This option, `-norc`, prevents loading of the RC file.

`-i` initfile ...
  Specifies initialization files to be `load`ed at startup. These should be lisp files (source or compiled). Several `-i` options can be given; all the specified files will be loaded in order.

`-c` lispfile ...
  Compiles the specified lispfiles to bytecode (*.fas). The compiled files can then be `load`ed instead of the sources to gain efficiency.

`-o` outputfile
  Specifies the output file or directory for the compilation of the last specified lispfile.

`-l`
  A bytecode listing (*.lis) of the files being compiled will be produced. Useful only for debugging purposes. See the documentation of `compile-file` for details.

`-x` expressions
  Executes a series of arbitrary expressions instead of a read-eval-print loop. The values of the expressions will be output to standard output. Due to the argument processing done by the shell, the expressions must be enclosed in double quotes, and double quotes and backslashes must be preceded by backslashes.

lispfile [ argument ... ]
  Loads and executes a lispfile. There will be no read-eval-print loop. Before lispfile is loaded, the variable `*args*` will be bound to a list of strings, representing the arguments. #ifdef UNIX The first line of lispfile may start with `#!`, thus permitting `clisp` to be used as a script interpreter. #endif If lispfile is `-`, the standard input is used instead of a file. If lispfile is an empty string `""`, the rest of the arguments is still available in `*args*`, for parsing by the `init-function` of the current image. This option must be the last one. No RC file will be executed.

#ifdef EMUNIX
`@`optionfile
  substitutes the contents of optionfile as arguments. Each line of optionfile is treated as a separate argument to `clisp`.

#endif

#ifdef AMIGAOS

## Workbench

Two kinds of tooltypes are supported:

`WINDOW=`windowspec
  `clisp` will communicate with the console window or pipe specified by windowspec.

`ARGS=`arguments
  Specifies the command line arguments for `clisp`. Within arguments the token `*` may be used to denote the project's filename. arguments defaults to `-i *` which means that the file will be `load`ed (see above).

#endif

## Reference

The language implemented mostly conforms to

> ANSI Common Lisp standard X3.226-1994

available online as the

> Common Lisp HyperSpec ("CLHS" for short)

which supersedes the earlier specifications

> Guy L. Steele Jr.: Common Lisp - The Language. Digital Press. 2nd edition 1990, 1032 pages. ("CLtL2" for short)

and

> Guy L. Steele Jr.: Common Lisp - The Language. Digital Press. 1st edition 1984, 465 pages. ("CLtL1" for short)

## Use

`help`
  to get some on-line help.

`(apropos` name`)`
  lists the symbols relating to name.

`(exit)` or `(quit)` or `(bye)`
  to quit `clisp`.

#if defined(UNIX) || defined(MSDOS) || defined(AMIGAOS) || defined(RISCOS)
#if (defined(UNIX) && !defined(UNIX_CYGWIN32)) || defined(RISCOS) EOF (Ctrl-D) #endif #if defined(MSDOS) || defined(UNIX_CYGWIN32) EOF (Ctrl-Z) #endif #ifdef AMIGAOS EOF (Ctrl-\e) #endif
  to leave the current read-eval-print loop.

#endif #ifdef GNU_READLINE
arrow keys
  for editing and viewing the input history.

Tab key
  to complete the symbol's name you are just typing.

#endif

## Files

#ifdef UNIX
`clisp`
  startup driver (a script or an executable)

#endif
#if defined(UNIX) `lisp.run` #endif #if defined(MSDOS) `lisp.exe` #endif #if defined(AMIGAOS) `lisp.run` #endif #if defined(RISCOS) `lisp` #endif
  main executable (runtime)

`lispinit.mem`
  initial memory image

`config.lisp`
  site-dependent configuration

`*.lisp`
  lisp source

`*.fas`
  lisp code, compiled by `clisp`

`*.lib`
  lisp source library information, generated and used by the `clisp` compiler

`*.c`
  C code, compiled from lisp source by `clisp` (for the FFI)

#ifdef HAVE_ENVIRONMENT

## Environment

`CLISP_LANGUAGE`
  specifies the language `clisp` uses to communicate with the user. The value may be `english`, `deutsch`, `francais` and defaults to `english`. The `-L` option can be used to override this environment variable.

#ifdef AMIGAOS
`Language`
  specifies the language `clisp` uses to communicate with the user, unless it is already specified through the environment variable `CLISP_LANGUAGE` or the `-L` option. The value may be as above.

#endif #ifdef UNICODE
`LC_CTYPE`
  specifies the locale which determines the character set in use. The value can be of the form `language` or `language_country` or `language_country.charset`, where language is a two-letter ISO 639 language code (lower case), country is a two-letter ISO 3166 country code (upper case). charset is an optional character set specification, and needs normally not be given because the character set can be inferred from the language and country.

#endif
`LANG`
  specifies the language `clisp` uses to communicate with the user, unless it is already specified through the environment variable `CLISP_LANGUAGE` or the `-L` option. #ifdef UNICODE It also specifies the locale determining the character set in use, unless already specified through the environment variable `LC_CTYPE`. #endif The value may begin with a two-letter ISO 639 language code, for example `en`, `de`, `fr`.

#ifdef UNIX
`HOME` and `USER`
  are used for determining the value of the function `user-homedir-pathname`. (Unix implementation only.)

#endif #ifdef UNIX
`SHELL` (Unix implementation only)
  is used to find the interactive command interpreter called by `(shell)`.

#endif #ifdef MSDOS
`COMSPEC` (DOS, OS/2 implementations only)
  is used to find the command interpreter called by the function `(shell)`.

#endif #ifdef UNIX
`TERM`
  determines the screen size recognized by the pretty printer.

#endif #ifdef EMUNIX_PORTABEL
`TERM`
  specifies the terminal emulation `clisp` relies on. If you have `ANSI.SYS` loaded, possible values are `ansi`, `ansi-color-2`, `ansi-color-3` and `mono`.

`TERMCAP`
  should be set to the slashified file name of the terminal capabilities database `termcap.dat`.

#endif #ifdef MULTIMAP_MEMORY_VIA_FILE
`TMPDIR` (Sparc implementation only)
  specifies the directory where the temporary core file is to be held.

#endif

## See also

impnotes.html, `cmucl`(1), `emacs`(1), `xemacs`(1).

## Bugs

#ifdef SPVW_MIXED_BLOCKS
- The memory management scheme is not very flexible.
#endif
- Not all extensions from ANSI CL are supported.
- No on-line documentation beyond `apropos` and `describe` is available.
#ifdef EMUNIX
- Stack overflow aborts the program ungracefully, with a register dump.
- Pressing Control-C may not interrupt `clisp` in every situation.
- Calling the function `execute` on batch files crashes the machine.
#endif #ifdef UNIX_COHERENT
- `*keyboard-input*` does not recognize Ctrl-S and Ctrl-Q.
#endif

## Projects

- Write on-line documentation.
- Enhance the compiler so that it can inline local functions.
- Specify a portable set of window and graphics operations.
- Add Multi-Threading capabilities, via OS threads.

## Authors

Bruno Haible and Michael Stoll.

Last modified: 31 May 2001.